Declare Function VkKeyScan Lib "Keyboard" (ByVal cChar As Integer) As Integer
Declare Function WriteProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String) As Integer
Declare Function CreatePopUpMenu Lib "User" () As Integer
Declare Function CreateMenu Lib "User" () As Integer
Declare Function TrackPopupMenu Lib "User" (ByVal hMenu As Integer, ByVal wFlags As Integer, ByVal x As Integer, ByVal Y As Integer, ByVal nReserved As Integer, ByVal hWnd As Integer, lpReserved As Any) As Integer
Declare Function AppendMenu Lib "User" (ByVal hMenu As Integer, ByVal wFlags As Integer, ByVal wIDNewItem As Integer, ByVal lpNewItem As Any) As Integer
Declare Function DestroyMenu Lib "User" (ByVal hMenu As Integer) As Integer
Declare Function DeleteMenu Lib "User" (ByVal hMenu As Integer, ByVal nPosition As Integer, ByVal wFlags As Integer) As Integer
Declare Function InsertMenu Lib "User" (ByVal hMenu As Integer, ByVal nPosition As Integer, ByVal wFlags As Integer, ByVal wIDNewItem As Integer, ByVal lpNewItem As Any) As Integer
Declare Sub SwitchToThisWindow Lib "User" (ByVal hWnd As Integer, ByVal OpenItUp As Integer)

Global P$(5)
Global ShortP$(5)
Global Q$(5)
Global FontChangedNotYetSized As Integer

Global Const MF_BYPOSITION = &H400
Global Const MF_BYCOMMAND = &H0

Global LastHour As Integer
Global LastJob As Integer
Global PicSize As Integer
Global PicSize2 As Integer
Global PicSize3 As Integer
Global PicSize4 As Integer


Type POINTAPI
    x As Integer
    Y As Integer
End Type

Declare Sub ClientToScreen Lib "User" (ByVal hWnd As Integer, lpPoint As POINTAPI)

Type ProgramType
    Group As String
    ProgramName As String
    ProgramPath As String
End Type

Type MSG
    hWnd As Integer
    message As Integer
    wParam As Integer
    lParam As Long
    time As Long
    pt As POINTAPI
End Type

Type TaskEntry
    dwSize As Long
    hTask As Integer
    hTaskParent As Integer
    hInstance As Integer
    hModule As Integer
    wSS As Integer
    wSP As Integer
    wStackTop As Integer
    wStackMinimum As Integer
    wStackBottom As Integer
    wcEvents As Integer
    hQueue As Integer
    szModule As String * 10
    wpSPOFfset As Integer
    hNext As Integer
End Type

Type MemManInfoType
    dwSize As Long
    dwLargestFreeBlock As Long
    dwMaxPagesAvailable As Long
    dwMaxPagesLockable As Long
    dwTotalLinearSpace As Long
    dwTotalUnlockedPages As Long
    dwFreePages As Long
    dwTotalPages As Long
    dwFreeLinearSpace As Long
    dwSwapFilePages As Long
    wPageSize As Integer
End Type

Declare Function TaskFirst Lib "toolhelp.dll" (lpTaskEntry As TaskEntry) As Integer
Declare Function TaskNext Lib "toolhelp.dll" (lpTaskEntry As TaskEntry) As Integer
Declare Function MemManInfo Lib "toolhelp.dll" (lpmmi As MemManInfoType) As Integer
Global myMess As MSG
Global Program() As ProgramType
Global Programs As Integer

Global hMainMenu As Integer
Global hSubMenu() As Integer
Global hSubMenus As Integer
Global hTaskMenu As Integer
Type TLType
  WTitle As String * 200
  hWnd As Integer
End Type


Global TaskList() As TLType
Global TaskListItems As Integer

Global Const MF_STRING = &H0
Global Const MF_SEPARATOR = &H800
Global Const MF_POPUP = &H10

Global Const IDM_ITEMS = 0
Global Const IDM_SETTINGS = 10001
Global Const IDM_EXIT = 10002
Global Const IDM_ABOUT = 10003
Global Const IDM_TASKS = 20000

'--------------------------------------------------------

Declare Function GetDriveType Lib "Kernel" (ByVal nDrive As Integer) As Integer
Declare Function GetWindowsDirectory Lib "Kernel" (ByVal lpBuffer As String, ByVal nSize As Integer) As Integer

Global Drives%
Global Drive(26)  As String
Global OldDate&
Global OldDriveList As String

Global Const BLACK = &H0&
Global Const RED = &HFF&
Global Const GREEN = &HFF00&
Global Const YELLOW = &HFFFF&
Global Const BLUE = &HFF0000
Global Const MAGENTA = &HFF00FF
Global Const CYAN = &HFFFF00
Global Const white = &HFFFFFF

Global Const gray = &H808080

'Fonts Dialog Flags
Global Const CF_SCREENFONTS = &H1&
Global Const CF_PRINTERFONTS = &H2&
Global Const CF_BOTH = &H3&
Global Const CF_SHOWHELP = &H4&
Global Const CF_INITTOLOGFONTSTRUCT = &H40&
Global Const CF_USESTYLE = &H80&
Global Const CF_EFFECTS = &H100&
Global Const CF_APPLY = &H200&
Global Const CF_ANSIONLY = &H400&
Global Const CF_NOVECTORFONTS = &H800&
Global Const CF_NOSIMULATIONS = &H1000&
Global Const CF_LIMITSIZE = &H2000&
Global Const CF_FIXEDPITCHONLY = &H4000&
Global Const CF_WYSIWYG = &H8000&                        'must also have CF_SCREENFONTS & CF_PRINTERFONTS
Global Const CF_FORCEFONTEXIST = &H10000
Global Const CF_SCALABLEONLY = &H20000
Global Const CF_TTONLY = &H40000
Global Const CF_NOFACESEL = &H80000
Global Const CF_NOSTYLESEL = &H100000
Global Const CF_NOSIZESEL = &H200000
Global Const OFN_HIDEREADONLY = &H4&

Declare Function SetWindowPos Lib "User" (ByVal hWnd As Integer, ByVal hWndInsertAfter As Integer, ByVal x As Integer, ByVal Y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer) As Integer
Declare Function BitBlt% Lib "gdi" (ByVal hDestDC%, ByVal x%, ByVal Y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal XSrc%, ByVal YSrc%, ByVal dwRop&)
Global CFlag%
Global DblCFlag%
Global Mess$
Global SP$
Global OldWid%
Global StartMess&
Global HeightOffset&
Global LastTime&
Declare Function GetModuleHandle Lib "Kernel" (ByVal lpModuleName As String) As Integer
Declare Function GetHeapSpaces Lib "Kernel" (ByVal hModule As Integer) As Long  '*UNDOCUMENTED*
Declare Function GetFreeSpace Lib "Kernel" (ByVal wFlags As Integer) As Long
Declare Function GetFreeSystemResources Lib "User" (ByVal fuSysResource As Integer) As Integer
Declare Function DiskInfo Lib "DiskInfo.DLL" (ByVal DriveNum%, ByVal DriveInfo%) As Long

Function CalcFreeResources (file As String)
info& = GetHeapSpaces(GetModuleHandle(file))
CalcFreeResources = (LowWord(info&) / HighWord(info&))
End Function

Function CreateTaskMenu () As Integer
'Dim TE As TaskEntry
'TMenu = CreatePopUpMenu()
'TE.dwSize = 40
't% = TaskFirst(TE)
'While t%
'   t% = TaskNext(TE)
'   If t% Then T1% = AppendMenu(TMenu, MF_STRING, TE.hTask, TE.szModule)
'Wend
'CreateTaskMenu = TMenu


Dim WName As String * 200
TaskListItems = 0
hWnd = GetTopWindow(0)
While hWnd <> 0
   If IsWIndowVisible(hWnd) And IsWindowEnabled(hWnd) Then
      TL& = GetWindowLong(hWnd, GWL_STYLE)
      If (TL& And WS_POPUP) <> WS_POPUP Then
	 WName = ""
	 TT% = GetWindowText(hWnd, WName, 200)
	 WN$ = Trim$(WName)
	 If Asc(WN$) <> 0 Then
	    If Left$(WN$, 10) <> "AllTheTime" Then
	       TaskListItems = TaskListItems + 1
	       ReDim Preserve TaskList(TaskListItems)
	       TaskList(TaskListItems).WTitle = WN$
	       TaskList(TaskListItems).hWnd = hWnd
	    End If
	 'Debug.Print WN$, hwnd
	 End If
      End If
   End If
   hWnd = GetWindow(hWnd, GW_HWNDNEXT)
Wend

Call QuickSort(1, TaskListItems)
TMenu = CreatePopUpMenu()
For I% = 1 To TaskListItems
T1% = AppendMenu(TMenu, MF_STRING, IDM_TASKS + I%, TaskList(I%).WTitle)
Next I%
CreateTaskMenu = TMenu
End Function

Function DecodeQuotes (ByVal S$) As String
For I% = 1 To Len(S$)
If Mid$(S$, I%, 1) = Chr$(129) Then Mid$(S$, I%, 1) = Chr$(34)
Next I%
DecodeQuotes = S$
End Function

Sub DeleteMenus ()
For I% = 1 To hSubMenus
   T% = DestroyMenu(hSubMenu(I%))
Next I%
T% = DestroyMenu(hTaskMenu)
T% = DestroyMenu(hMainMenu)
Call SaveSettings

Unload Settings
Y% = Ctl3dUnregister(hw%)

End Sub

Sub DrawShadow (Form1 As Form)

Const white = &HFFFFFF
Const gray = &H808080
Const BLACK = 0
Const lighTGRAY = &HC0C0C0
Form1.Line (0, 0)-(Form1.ScaleWidth - 15, 0), BLACK
Form1.Line (Form1.ScaleWidth - 15, 0)-(Form1.ScaleWidth - 15, Form1.ScaleHeight), BLACK
Form1.Line (0, Form1.ScaleHeight - 15)-(Form1.ScaleWidth - 15, Form1.ScaleHeight - 15), BLACK
Form1.Line (0, 0)-(0, Form1.ScaleHeight - 15), BLACK

Form1.Line (15, 15)-(Form1.ScaleWidth - 30, 15), white
Form1.Line (Form1.ScaleWidth - 30, 15)-(Form1.ScaleWidth - 30, Form1.ScaleHeight - 15), gray
Form1.Line (15, Form1.ScaleHeight - 30)-(Form1.ScaleWidth - 30, Form1.ScaleHeight - 30), gray
Form1.Line (15, 15)-(15, Form1.ScaleHeight - 30), white

End Sub     ' DrawShadow()

Function DriveSpace (D As String) As String
DNum = Asc(UCase$(D)) - Asc("A") + 1
TSpace& = DiskInfo(DNum, 1)
If TSpace& > 1024& * 1024& Then
   TS$ = Format$(DiskInfo(DNum, 1) / (1024& * 1024&), "#,###,##0.0mb")
Else
   TS$ = Format$(DiskInfo(DNum, 1) / 1024&, "#,###,##0k")
End If
DriveSpace = Chr(DNum + Asc("A") - 1) + ":" + TS$ + " "
End Function

Function EncodeQuotes (ByVal S$) As String
For I% = 1 To Len(S$)
If Mid$(S$, I%, 1) = Chr$(34) Then Mid$(S$, I%, 1) = Chr$(129)
Next I%
EncodeQuotes = S$
End Function

Function getsystemresources ()
gdires = CalcFreeResources("GDI")
userres = CalcFreeResources("USER")
If gdires < userres Then
 getsystemresources = gdires
Else
 getsystemresources = userres
End If
End Function

Function HighWord (dlong As Long) As Long
HighWord = (dlong And Not &HFFFF&) / &H10000 And &HFFFF&
End Function

Function LowWord (dlong As Long) As Long
LowWord = dlong And &HFFFF&
End Function

Sub PictureMenuMouseDown (Button As Integer, Shift As Integer, x As Single, Y As Single)
Dim lpPoint As POINTAPI

SoundABorted = True
AllTheTime.Picture1.Picture = AllTheTime.MoonSun.GraphicCell(23)

lpReserved& = 0
nReserved% = 0
T% = AllTheTime.ScaleMode
AllTheTime.ScaleMode = 3
lpPoint.x = 0 '2   '-2'Picture1.ScaleWidth '- 2 '+ Form1.Left + Picture1.Left
lpPoint.Y = AllTheTime.ScaleTop + AllTheTime.ScaleHeight' - 4'+ AllTheTime.Form1.Top + AllTheTime.Picture1.Top
Call ClientToScreen(AllTheTime.hWnd, lpPoint)
AllTheTime.ScaleMode = T%
T% = DeleteMenu(hMainMenu, 0, MF_BYPOSITION)
'Destroymenu??
hTaskMenu = CreateTaskMenu()
T% = InsertMenu(hMainMenu, 0, MF_BYPOSITION Or MF_POPUP, hTaskMenu, "&Switch to...")
T% = TrackPopupMenu(hMainMenu, wFlags%, lpPoint.x, lpPoint.Y, nReserved%, AllTheTime.hWnd, lpReserved&)
AllTheTime.Picture1.Picture = AllTheTime.MoonSun.GraphicCell(22)
End Sub

Sub PositionATT ()
'SavedVis = AllTheTime.Visible
'AllTheTime.Visible = False
If AllTheTime.Left >= Screen.Width - 15 Then Exit Sub

If Settings.Option3D1(0).Value = True Then
   AllTheTime.Left = 0
   AllTheTime.Top = 0
End If
If Settings.Option3D1(1).Value = True Then
   AllTheTime.Left = Screen.Width - AllTheTime.Width
   AllTheTime.Top = 0
End If
If Settings.Option3D1(2).Value = True Then
   AllTheTime.Left = Screen.Width - AllTheTime.Width
   AllTheTime.Top = Screen.Height - AllTheTime.Height
End If
If Settings.Option3D1(3).Value = True Then
   AllTheTime.Left = 0
   AllTheTime.Top = Screen.Height - AllTheTime.Height
End If
If Settings.Option3D1(4).Value = True Then
   AllTheTime.Left = PosLeft
   AllTheTime.Top = PosTop
End If
Moved = False
'AllTheTime.Visible = SavedVis
End Sub

Sub SaveSettings ()
Moved = False
A% = WriteProfileString("AllTheTime", "ShowDate", Settings.Check3D1(0).Value)
A% = WriteProfileString("AllTheTime", "ShowTime", Settings.Check3D1(1).Value)
A% = WriteProfileString("AllTheTime", "ShowMemory", Settings.Check3D1(2).Value)
A% = WriteProfileString("AllTheTime", "ShowResource", Settings.Check3D1(3).Value)
A% = WriteProfileString("AllTheTime", "ShowSun", Settings.Check3D1(4).Value)
A% = WriteProfileString("AllTheTime", "ShowDrive", Settings.Check3D1(5).Value)
A% = WriteProfileString("AllTheTime", "ShowPlus", Settings.Check3D1(6).Value)
A% = WriteProfileString("AllTheTime", "ShowBlock", Settings.Check3D1(7).Value)
A% = WriteProfileString("AllTheTime", "ShowPrint", Settings.Check3D1(8).Value)
A% = WriteProfileString("AllTheTime", "DateFormat", EncodeQuotes(Settings.DateList.Text))
A% = WriteProfileString("AllTheTime", "TimeFormat", EncodeQuotes(Settings.TimeList.Text))
A% = WriteProfileString("AllTheTime", "DriveFormat", Settings.DriveList.Text)
T$ = Trim$(Settings.DriveList.Text)
If T$ <> Settings.DriveList.List(0) And T$ <> Settings.DriveList.List(1) Then
   Settings.DriveList.List(2) = T$
   Settings.DriveList.Text = T$
End If


A% = WriteProfileString("AllTheTime", "StayOnTop", Settings.StayOnTop.Value)
A% = WriteProfileString("AllTheTime", "Chime", Settings.Chime.Value)
A% = WriteProfileString("AllTheTime", "Hourly", Settings.Hourly.Value)
A% = WriteProfileString("AllTheTime", "ChimeFile", Settings.CMDialog1.Filename)
A% = WriteProfileString("AllTheTime", "FullScreen", Settings.FullScreen.Value)
A% = WriteProfileString("AllTheTime", "ToggleHotKey", Settings.Text1(0).Text)
A% = WriteProfileString("AllTheTime", "RotateHotKey", Settings.Text1(1).Text)
A% = WriteProfileString("AllTheTime", "PlusKey", Settings.Text1(2).Text)
M$ = "1"
For I% = 0 To 4
   If Settings.Option3D1(I%).Value Then M$ = Str$(I% + 1)
Next I%
A% = WriteProfileString("AllTheTime", "Position", M$)
A% = WriteProfileString("AllTheTime", "SpaceBetween", Settings.SpacesScr.Value)
A% = WriteProfileString("AllTheTime", "PosLeft", Format$(PosLeft%))
A% = WriteProfileString("AllTheTime", "PosTop", Format$(PosTop%))

A% = WriteProfileString("AllTheTime", "FontName", AllTheTime.FontName)
A% = WriteProfileString("AllTheTime", "FontSize", AllTheTime.FontSize)
A% = WriteProfileString("AllTheTime", "FontBold", AllTheTime.FontBold)
A% = WriteProfileString("AllTheTime", "FontItalic", AllTheTime.FontItalic)
A% = WriteProfileString("AllTheTime", "FontUnderline", AllTheTime.FontUnderline)
A% = WriteProfileString("AllTheTime", "FontStrikethru", AllTheTime.FontStrikethru)
A% = WriteProfileString("AllTheTime", "ForeColor", AllTheTime.ForeColor)
For I% = 1 To 5
A% = WriteProfileString("AllTheTime", "Order" + Format$(I%), Settings.OrderPanel(I%).Tag)
Next I%


Call SetUpVirtualKeys

End Sub

Sub SetSize ()
If AllTheTime.WindowState = 1 Then Exit Sub
PicSize = 0
PicSize2 = 0
PicSize3 = 0
PicSize4 = 0

If AllTheTime.SeasonPic.Visible Then
   PicSize = AllTheTime.SeasonPic.Width + 30
   PicSize2 = AllTheTime.MoonPic.Width + 30
End If

If AllTheTime.Picture1.Visible Then
   PicSize3 = AllTheTime.Picture1.Width + 30
   AllTheTime.PrtStatus.Left = AllTheTime.Picture1.Width + AllTheTime.Picture1.Left + 45
Else
   AllTheTime.PrtStatus.Left = 45
End If

If AllTheTime.PrtStatus.Visible Then
   PicSize4 = AllTheTime.PrtStatus.Width + 30
   AllTheTime.MoonPic.Left = AllTheTime.PrtStatus.Left + AllTheTime.PrtStatus.Width + 30
Else
   If AllTheTime.Picture1.Visible Then
      AllTheTime.MoonPic.Left = AllTheTime.Picture1.Left + AllTheTime.Picture1.Width + 30
   Else
      AllTheTime.MoonPic.Left = 30
   End If
End If

'If AllTheTime.Picture1.Visible Then
  ' PicSize3 = AllTheTime.Picture1.Width + 30
'   AllTheTime.MoonPic.Left = AllTheTime.Picture1.Width + AllTheTime.Picture1.Left '+ 30
'Else
'   AllTheTime.MoonPic.Left = 30
'End If

'If AllTheTime.PrtStatus.Visible Then
'   PicSize4 = AllTheTime.PrtStatus.Width + 30
'   T = AllTheTime.MoonPic.Left
'   If AllTheTime.MoonPic.Visible Then
'      AllTheTime.PrtStatus.Left = T + AllTheTime.MoonPic.Width + 30
'   Else
'      AllTheTime.PrtStatus.Left = T
'   End If

'End If

If Settings.FullScreen.Value Then
   NuWidth = Screen.Width
   'PosLeft = 0
   'AllTheTime.Left = 0
   AllTheTime.SeasonPic.Left = AllTheTime.Width - PicSize - 15
   NewWidth = 0
Else
   NewWidth = AllTheTime.TextWidth(Mess$) + 180 + PicSize + PicSize2 + PicSize3 + PicSize4
End If

   If NewWidth <> AllTheTime.Width Then
      StartMess = 90
      If PicSize <> 0 Then
      End If
      If (PicSize <> 0) Or (PicSize3 <> 0) Or (PicSize4 <> 0) Then
	 StartMess = PicSize2 + 90 + PicSize3 + PicSize4
      End If
      If Not Settings.FullScreen.Value Then NuWidth = AllTheTime.TextWidth(Mess$) + 180 + PicSize + PicSize2 + PicSize3 + PicSize4
      'Here
      AllTheTime.Line (AllTheTime.ScaleWidth - 15, 15)-(AllTheTime.ScaleWidth - 15, AllTheTime.ScaleHeight - 30), AllTheTime.BackColor   'was 45
      AllTheTime.Line (AllTheTime.ScaleWidth - 30, 15)-(AllTheTime.ScaleWidth - 30, AllTheTime.ScaleHeight - 30), AllTheTime.BackColor   '45
      AllTheTime.SeasonPic.Left = NuWidth - PicSize - 15
      AllTheTime.Width = NuWidth

   End If

TempHeight = AllTheTime.TextHeight(Mess$) + 75
If (AllTheTime.SeasonPic.Height + 90 > TempHeight) And (AllTheTime.SeasonPic.Visible Or AllTheTime.Picture1.Visible Or AllTheTime.PrtStatus.Visible) Then
   AllTheTime.Height = AllTheTime.SeasonPic.Height + 90
   ExtraHeight = AllTheTime.Height - TempHeight
   HeightOffset = ExtraHeight / 2
   '
Else
   AllTheTime.Height = TempHeight
   HeightOffset = 0
End If
DrawShadow AllTheTime
FontChangedNotYetSized = False
End Sub

Sub SetStayOnTop (Value)
wFlags = &H2 Or &H1 Or &H40 Or &H10
If Value Then
   wOn_Top% = SetWindowPos(AllTheTime.hWnd, -1, 0, 0, 0, 0, wFlags)
Else
   wNormal% = SetWindowPos(AllTheTime.hWnd, -2, 0, 0, 0, 0, wFlags)
   AllTheTime.ZOrder 1
End If

End Sub

Sub SetTime ()
Dim MM As MemManInfoType
'TMenu = CreatePopUpMenu()


Dim Mo As Integer
Dim Dy As Integer
Dim Yr As Integer

OurTime = Time
ThisHour = Val(Format$(OurTime, "hh"))

T$ = ""
ShortT$ = ""
D$ = ""
ShortD$ = ""
M$ = ""
ShortM$ = ""
R$ = ""
ShortR$ = ""
S$ = ""
ShortS$ = ""

If AllTheTime.WindowState = 1 Then
   'Are we ever iconized ????
   'What was I thinking of?
   C$ = AllTheTime.Caption
   NC$ = Format$(Time, Settings.TimeList.Text)
   If C$ <> NC$ Then
      AllTheTime.Caption = NC$
   End If
   'AllTheTime.Icon = LoadPicture()
   'Exit Sub
End If

If OldDriveList <> Settings.DriveList.Text Then Call SetupDriveList

On Error Resume Next
If Settings.Check3D1(0).Value Then
   D$ = Format$(Date, Settings.DateList.Text)
   ShortD$ = Format$(Date, "m/d")
End If
If Err <> 0 Then D$ = Settings.DateList.Text

On Error Resume Next
If Settings.Check3D1(1).Value Then
   T$ = Format$(OurTime, Settings.TimeList.Text)
   ShortT$ = Format$(OurTime, "h:nn")
End If
If Err <> 0 Then T$ = Settings.TimeList.Text
On Error GoTo 0

If Settings.Check3D1(2).Value Then
   M$ = Format$(GetFreeSpace(0) \ 1024, "#,##0") + "k"
   ShortM$ = M$
   MM.dwSize = 42
   Boo% = MemManInfo(MM)
    'Debug.Print MM.dwSize
    'Debug.Print MM.dwLargestFreeBlock
    'Debug.Print MM.dwMaxPagesAvailable * 4
    'Debug.Print MM.dwMaxPagesLockable * 4
    'Debug.Print MM.dwTotalLinearSpace * 4
    'Debug.Print MM.dwTotalUnlockedPages * 4
    'Debug.Print MM.dwFreePages * 4
    'Debug.Print MM.dwTotalPages * 4
    'Debug.Print MM.dwFreeLinearSpace * 4
    'Debug.Print MM.dwSwapFilePages * 4
    'Debug.Print MM.wPageSize
    'Debug.Print
    'Debug.Print MM.dwTotalPages * 4
    'Debug.Print MM.dwSwapFilePages * 4
    '
    'Debug.Print MM.dwTotalLinearSpace * 4
    'Debug.Print MM.dwFreeLinearSpace * 4
    '
    'Debug.Print ((MM.dwTotalPages + MM.dwSwapFilePages) * 4) - (MM.dwTotalLinearSpace - MM.dwFreeLinearSpace) * 4

   If Settings.Check3D1(7).Enabled And Settings.Check3D1(7).Value Then
      M$ = M$ + " / " + Format$((((MM.dwTotalPages + MM.dwSwapFilePages) * 4) - (MM.dwTotalLinearSpace - MM.dwFreeLinearSpace) * 4), "#,##0") + "k"
   End If
End If

If Settings.Check3D1(3).Value Then
   'R$ = Format$(getsystemresources(), "##.#%")
   R$ = Format$(GetFreeSystemResources(0), "##") + "%"
   ShortR$ = R$
End If

If Settings.Check3D1(5).Value Then
'DriveNum% is the drive that you want the figures for: 0=Default Drive, 1=drive A, 2=B, 3=C etc.
'DriveInfo% is the information you want: 1 = Free Space, 2 = Total Space, 3 = Total Clusters, 4 = Available Clusters, 5 = Sectors per Cluster, 6 = Bytes per Sector.
For I% = 1 To Drives%
S$ = S$ + DriveSpace$(Drive(I%))
If I% = 1 Then
   TP% = InStr(S$, ".")
   If TP% > 0 Then
      ShortS$ = Left$(S$, TP% - 1)
   Else
      ShortS$ = S$
   End If
End If
Next I%
S$ = Trim$(S$)
'S$ = S$ + DriveSpace$(("C"))
End If

If Settings.Check3D1(4).Value Then
   AllTheTime.SeasonPic.Visible = True
   AllTheTime.MoonPic.Visible = True
Else
   AllTheTime.SeasonPic.Visible = False
   AllTheTime.MoonPic.Visible = False
End If

If Settings.Check3D1(6).Value Then
   AllTheTime.Picture1.Visible = True
Else
   AllTheTime.Picture1.Visible = False
End If

If Settings.Check3D1(8).Value Then
   AllTheTime.PrtStatus.Visible = True
   TJobs = PrinterJobs()
   'If LastJob <> TJobs Then
      If TJobs > 0 Then
	 AllTheTime.PrtActive.Left = AllTheTime.PrtStatus.Left
	 AllTheTime.PrtActive.Top = 30
	 AllTheTime.PrtInactive.Top = 10030
      Else
	 AllTheTime.PrtInactive.Left = AllTheTime.PrtStatus.Left
	 AllTheTime.PrtActive.Top = 10030
	 AllTheTime.PrtInactive.Top = 30
      End If
      LastJob = TJobs
   'End If
Else
   AllTheTime.PrtStatus.Visible = False
   AllTheTime.PrtActive.Top = 10030
	 AllTheTime.PrtInactive.Top = 10030
End If

'Set seasonpic to appropriate "sun"
'6am to 12noon (6-12) -> 0
'12  to 6pm    (12-18)-> 1
'6pm to 12mid  (18-24)-> 2
'12m to 6am    (0-6)  -> 3
MorningNight = ((Hour(OurTime) + 18) \ 6) Mod 4
OurDate = Date
If ((LastHour <> ThisHour) Or (OldDate <> OurDate)) And (AllTheTime.Height > 100) Then
   Mo = Month(OurDate)
   Dy = Day(OurDate)
   Yr = Year(OurDate)
   Call CalcMoonPhases(Yr, Mo, Dy, 0)
   If Mo < 3 Then
      Season = 1
   Else
      If Mo = 3 And Dy < 21 Then
	 Season = 1
      Else
	 If Mo < 6 Then
	    Season = 2
	 Else
	    If Mo = 6 And Dy < 21 Then
	       Season = 2
	    Else
	       If Mo < 9 Then
		  Season = 3
	       Else
		  If Mo = 9 And Dy < 21 Then
		     Season = 3
		  Else
		     If Mo < 12 Then
			Season = 0
		     Else
			If Mo = 12 And Dy < 21 Then
			   Season = 0
			Else
			   Season = 1
			End If
		     End If
		  End If
	       End If
	    End If
	 End If
      End If
   End If
   OldDate = OurDate
   AllTheTime.SeasonPic.Picture = AllTheTime.MoonSun.GraphicCell(1 + MorningNight * 5 + Season)
   AllTheTime.MoonPic.Picture = AllTheTime.MoonSun.GraphicCell(MoonSub)
End If

'AllTheTime.SeasonPic.Picture = AllTheTime.Sun(MorningNight + Season * 4).Picture
Q$(1) = T$
Q$(2) = D$
Q$(3) = S$
Q$(4) = M$
Q$(5) = R$
P$(1) = Q$(Settings.OrderPanel(1).Tag)
P$(2) = Q$(Settings.OrderPanel(2).Tag)
P$(3) = Q$(Settings.OrderPanel(3).Tag)
P$(4) = Q$(Settings.OrderPanel(4).Tag)
P$(5) = Q$(Settings.OrderPanel(5).Tag)
Q$(1) = ShortT$
Q$(2) = ShortD$
Q$(3) = ShortS$
Q$(4) = ShortM$
Q$(5) = ShortR$
ShortP$(1) = Q$(Settings.OrderPanel(1).Tag)
ShortP$(2) = Q$(Settings.OrderPanel(2).Tag)
ShortP$(3) = Q$(Settings.OrderPanel(3).Tag)
ShortP$(4) = Q$(Settings.OrderPanel(4).Tag)
ShortP$(5) = Q$(Settings.OrderPanel(5).Tag)
If Settings.Visible Then
   For I% = 1 To 5
      Settings.OrderPanel(I%).Caption = ShortP$(I%)
   Next I%
End If
If Settings.FullScreen.Value Then
   Mess$ = Trim$(P$(1) + SP$ + P$(2))
   Mess$ = Trim$(Mess$ + SP$ + P$(3))
   Mess$ = Trim$(Mess$ + SP$ + P$(4))
   Mess$ = Trim$(Mess$ + SP$ + P$(5))
   If (AllTheTime.TextWidth(Mess$) + StartMess& <> OldWid%) Then
       'Beep
       TMess$ = T$ + D$ + S$ + M$ + R$
       Extras% = 0
       Pad% = 120
       If AllTheTime.Picture1.Visible Then Pad% = Pad% + PicSize3 '+ 30
       If AllTheTime.SeasonPic.Visible Then Pad% = Pad% + PicSize + PicSize2 '+ 60
       If AllTheTime.PrtStatus.Visible Then Pad% = Pad% + PicSize4 '+ 30
       While AllTheTime.TextWidth(TMess$) + Pad% < Screen.Width
	  Extras% = Extras% + 1
	  TMess$ = TMess$ + " "
       Wend
       Extras% = Extras% - 2
       Spaces% = 0
       If T$ <> "" Then Spaces% = Spaces% + 1
       If D$ <> "" Then Spaces% = Spaces% + 1
       If S$ <> "" Then Spaces% = Spaces% + 1
       If M$ <> "" Then Spaces% = Spaces% + 1
       If R$ <> "" Then Spaces% = Spaces% + 1
       Spaces% = Spaces% - 1
       If Spaces% <= 0 Then Spaces% = 1
       SP$ = String$((Extras% \ Spaces%), 32)
       Mess$ = Trim$(P$(1) + SP$ + P$(2))
       Mess$ = Trim$(Mess$ + SP$ + P$(3))
       Mess$ = Trim$(Mess$ + SP$ + P$(4))
       Mess$ = Trim$(Mess$ + SP$ + P$(5))
   End If
   OldWid% = AllTheTime.TextWidth(Mess$) + StartMess&
Else
   SP$ = String$(Settings.SpacesScr.Value, 32)
   Mess$ = Trim$(P$(1) + SP$ + P$(2))
   Mess$ = Trim$(Mess$ + SP$ + P$(3))
   Mess$ = Trim$(Mess$ + SP$ + P$(4))
   Mess$ = Trim$(Mess$ + SP$ + P$(5))
End If
'here 1
AllTheTime.Line (30, 30)-Step(AllTheTime.ScaleWidth - 75, AllTheTime.ScaleHeight - 75), AllTheTime.BackColor, B
'AllTheTime.Line (AllTheTime.ScaleWidth - 15, 0)-(AllTheTime.ScaleWidth - 15, AllTheTime.ScaleHeight - 30), AllTheTime.BackColor
'AllTheTime.Line (45, 30)-Step(AllTheTime.ScaleWidth - 45, AllTheTime.ScaleHeight - 75), AllTheTime.BackColor, B
'AllTheTime.Line (AllTheTime.ScaleWidth - 15, 0)-(AllTheTime.ScaleWidth - 15, AllTheTime.ScaleHeight - 30), AllTheTime.BackColor
AllTheTime.CurrentY = 30 + HeightOffset   'WAS 30
AllTheTime.CurrentX = StartMess
'Call SetSize   'new!
If Not FontChangedNotYetSized Then
   AllTheTime.Print Mess$
Else
   LastTime = 0
End If


If (ThisHour <> LastHour) And (Settings.Chime.Value) And (AllTheTime.Height > 100) Then
    'play sound
    If SndPlaySOund(Settings.CMDialog1.Filename, 1) = 0 Then
       Beep
    Else
       SoundABorted = False
       If Settings.Hourly.Value And Not PlayOnceOnly% Then
	  Hours% = Hour(OurTime)
	  If Hours% > 12 Then Hours% = Hours% - 12
	  If Hours% = 0 Then Hours% = 12
	  For I% = 2 To Hours%
	     While SndPlaySOund(Settings.CMDialog1.Filename, 1 + SND_NOSTOP) = 0
		DoEvents
		If SoundABorted Then
		   x% = SndPlaySOund("", 0)
		   Exit For
		End If
		DoEvents
		DoEvents
		DoEvents
		DoEvents
		DoEvents
	     Wend
	  Next I%
       End If
    End If
    PlayOnceOnly = False
End If

LastHour = ThisHour

End Sub

Sub SetupDriveList ()
Dim lpBuffer As String * 256
Drives% = 0
lpBuffer = "A:\"
If Settings.DriveList.Text = "All hard drives" Then
   For I% = 0 To 25
      T% = GetDriveType(I%)
      If T% = 4 Or T% = 3 Then
	 Drives% = Drives% + 1
	 Drive(Drives%) = Chr$(Asc("A") + I%)
      End If
   Next I%
Else
   If Settings.DriveList.Text = "Windows drive" Then
      T% = GetWindowsDirectory(lpBuffer, 256)
      Drives% = 1
      Drive(1) = Left$(lpBuffer, 1)
   Else
      Drives% = 0
      For I% = 1 To Len(Settings.DriveList.Text)
	 TD$ = UCase$(Mid$(Settings.DriveList.Text, I%, 1))
	 If TD$ >= "A" And TD$ <= "Z" And Drives% < 26 Then
	    Drives% = Drives% + 1
	    Drive(Drives%) = TD$
	 End If
      Next I%
   End If
End If
OldDriveList = Settings.DriveList.Text
End Sub

Sub SetUpVirtualKeys ()
If Settings.Text1(0).Text <> "" Then VK_Toggle3 = VkKeyScan(Asc(Settings.Text1(0).Text))
If Settings.Text1(1).Text <> "" Then VK_Rotate3 = VkKeyScan(Asc(Settings.Text1(1).Text))
If Settings.Text1(2).Text <> "" Then VK_Plus3 = VkKeyScan(Asc(Settings.Text1(2).Text))
End Sub

